{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DuplicateRecordFields #-}
{-# LANGUAGE NamedFieldPuns #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE RecordWildCards #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-unused-matches #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.GuardDuty.Types.MalwareProtectionDataSourceFreeTrial
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.GuardDuty.Types.MalwareProtectionDataSourceFreeTrial where

import qualified Amazonka.Core as Core
import qualified Amazonka.Core.Lens.Internal as Lens
import qualified Amazonka.Data as Data
import Amazonka.GuardDuty.Types.DataSourceFreeTrial
import qualified Amazonka.Prelude as Prelude

-- | Provides details about Malware Protection when it is enabled as a data
-- source.
--
-- /See:/ 'newMalwareProtectionDataSourceFreeTrial' smart constructor.
data MalwareProtectionDataSourceFreeTrial = MalwareProtectionDataSourceFreeTrial'
  { -- | Describes whether Malware Protection for EC2 instances with findings is
    -- enabled as a data source.
    scanEc2InstanceWithFindings :: Prelude.Maybe DataSourceFreeTrial
  }
  deriving (Prelude.Eq, Prelude.Read, Prelude.Show, Prelude.Generic)

-- |
-- Create a value of 'MalwareProtectionDataSourceFreeTrial' with all optional fields omitted.
--
-- Use <https://hackage.haskell.org/package/generic-lens generic-lens> or <https://hackage.haskell.org/package/optics optics> to modify other optional fields.
--
-- The following record fields are available, with the corresponding lenses provided
-- for backwards compatibility:
--
-- 'scanEc2InstanceWithFindings', 'malwareProtectionDataSourceFreeTrial_scanEc2InstanceWithFindings' - Describes whether Malware Protection for EC2 instances with findings is
-- enabled as a data source.
newMalwareProtectionDataSourceFreeTrial ::
  MalwareProtectionDataSourceFreeTrial
newMalwareProtectionDataSourceFreeTrial =
  MalwareProtectionDataSourceFreeTrial'
    { scanEc2InstanceWithFindings =
        Prelude.Nothing
    }

-- | Describes whether Malware Protection for EC2 instances with findings is
-- enabled as a data source.
malwareProtectionDataSourceFreeTrial_scanEc2InstanceWithFindings :: Lens.Lens' MalwareProtectionDataSourceFreeTrial (Prelude.Maybe DataSourceFreeTrial)
malwareProtectionDataSourceFreeTrial_scanEc2InstanceWithFindings = Lens.lens (\MalwareProtectionDataSourceFreeTrial' {scanEc2InstanceWithFindings} -> scanEc2InstanceWithFindings) (\s@MalwareProtectionDataSourceFreeTrial' {} a -> s {scanEc2InstanceWithFindings = a} :: MalwareProtectionDataSourceFreeTrial)

instance
  Data.FromJSON
    MalwareProtectionDataSourceFreeTrial
  where
  parseJSON =
    Data.withObject
      "MalwareProtectionDataSourceFreeTrial"
      ( \x ->
          MalwareProtectionDataSourceFreeTrial'
            Prelude.<$> (x Data..:? "scanEc2InstanceWithFindings")
      )

instance
  Prelude.Hashable
    MalwareProtectionDataSourceFreeTrial
  where
  hashWithSalt
    _salt
    MalwareProtectionDataSourceFreeTrial' {..} =
      _salt
        `Prelude.hashWithSalt` scanEc2InstanceWithFindings

instance
  Prelude.NFData
    MalwareProtectionDataSourceFreeTrial
  where
  rnf MalwareProtectionDataSourceFreeTrial' {..} =
    Prelude.rnf scanEc2InstanceWithFindings
